
$(document).ready(function() {
    buildCTable();
});

function buildCTable() {
    var hs = $('#mycontent').find('h1,h2,h3,h4,h5,h6'); // mycontent is the id of the content div
    if (hs.length < 2)
        return;
    var s = '';
    s += '<div style="clear:both"></div>';
    s += '<div style="border:solid 1px #ccc; background:#eee; float:left; min-width:200px;padding:4px 10px;">';
    s += '<p style="text-align:right;margin:0;"><span style="float:left;">Table of Contents<a href="#" title="System would build the table of the contents by the tag H1 to H6">(?)</a></span><a href="#" onclick="javascript:return openct(this);" title="Expand">[+]</a></p>';
    s += '<ol style="display:none;margin-left:14px;padding-left:14px;line-height:160%;">';
    var old_h = 0, ol_cnt = 0;
    for (var i = 0; i < hs.length; i++) {
        var h = parseInt(hs[i].tagName.substr(1), 10);
        if (!old_h)
            old_h = h;
        if (h > old_h) {
            s += '<ol>';
            ol_cnt++;
        }
        else if (h < old_h && ol_cnt > 0) {
            s += '</ol>';
            ol_cnt--;
        }
        if (h == 1) {
            while (ol_cnt > 0) {
                s += '</ol>';
                ol_cnt--;
            }
        }
        old_h = h;
        var tit = hs.eq(i).text().replace(/^\d+[.、\s]+/g, '');
        tit = tit.replace(/[^a-zA-Z0-9_\-\s\u4e00-\u9fa5]+/g, '');

        if (tit.length < 100) {
            s += '<li><a href="#t' + i + '">' + tit + '</a></li>';
            hs.eq(i).html('<a name="t' + i + '"></a>' + hs.eq(i).html());
        }
    }
    while (ol_cnt > 0) {
        s += '</ol>';
        ol_cnt--;
    }
    s += '</ol></div>';
    s += '<div style="clear:both"></div>';
    $(s).insertBefore($('#mycontent')); // mycontent is the id of the content div
    
}

function openct(e) {
    if (e.innerHTML == '[+]') {
        $(e).attr('title', 'Shrink').html('[-]').parent().next().show();
    } else {
        $(e).attr('title', 'Expand').html('[+]').parent().next().hide();
    }
    e.blur();
    return false;
}


